/***************************************************************************************************
 * This is a demo project for Olimex TMS570-CAN
 * In order to work you must install the driver for JTag and ComPort (XDS100v2+com.ept)
 * using MProg. You must connect to HyperTerminal, Putty etc. with following configuration:
 * 9600
 * 8 Data bits
 * 1 stop bit
 * No Parity
 * On power-on reset welcome screen will be shown on the terminal and then the program
 * will return echo (next ASCII symbol). For example if you input 'a' the program will
 * return 'b' etc.
 * When Button 1 is down the Green LED is ON
 * When Button 2 is down the Yellow LED is ON
 ***************************************************************************************************/


/* USER CODE BEGIN (0) */
/* USER CODE END */


/* Include Files */

#include "sys_common.h"
#include "system.h"

/* USER CODE BEGIN (1) */

#include "spi.h"
#include "gio.h"
#include "sci.h"
#include <string.h>
#include <stdio.h>

/* USER CODE END */


/* USER CODE BEGIN (2) */
void BufPrintStr(char *str);
char getChar (void);
void putChar (char ch);

/* USER CODE END */

void main(void)
{
/* USER CODE BEGIN (3) */
	char c;

	spiInit();	// make all GPIOs
	sciInit();	//SCI1 is the UART console, SCI2 are all GPIOs

	BufPrintStr("Hello, World! :)\r\n");

	spiPORT5->DIR = spiPORT5->DIR & (~(1<<14 | 1<<15));	// buttons input
	spiPORT5->DIR = spiPORT5->DIR | (1<<19) | (1<<25);	// LEDs output
	while (1)
	{
		c = getChar ();
		if (c)								// character received?
			putChar (c+1);					// return next symbol in ASCII order
		if (!(spiPORT5->DIN & 0x20000))		// Button 1 pressed?
			gioSetBit(spiPORT5, 25, 1);		// LED2 (Green) ON
		else
			gioSetBit(spiPORT5, 25, 0);		// LED2 (Green) OFF

		if (!(spiPORT5->DIN & 0x40000))		// Button 2 pressed?
			gioSetBit(spiPORT5, 19, 1);		// LED1 (Yellow) ON
		else
			gioSetBit(spiPORT5, 19, 0);		// LED1 (Yellow) OFF
	}
/* USER CODE END */
}


/* USER CODE BEGIN (4) */
void gioNotification(intbit)
{
	return;
}

void spiGroupNotification(spiBASE_t *spi, unsigned group)
{
	return;
}

void spiNotification(spiBASE_t *spi, unsigned flags)
{
	return;
}

void sciNotification(sciBASE_t *sci, unsigned flags)
{

}

void BufPrintStr(char *str)
{
	unsigned int len;

	len = strlen(str);
	sciSend(sciREG1, len, (unsigned char *)str);
}

char getChar(void)
{
	char ch = (char)0;

	if ( sciIsRxReady(sciREG1) )
		ch = sciReceiveByte(sciREG1);

	return ch;
}

void putChar (char ch)
{
	if ( sciIsTxReady(sciREG1) )
		sciSendByte(sciREG1, ch);

	return;
}
/* USER CODE END */
